<?php
namespace ACL\Helpers\Instances;

use ACL\Repositories\Cliente;
use ACL\Repositories\Filioper;
use ACL\Repositories\Inteclie;
use ACL\Repositories\Novocodigo;
use Acl\Repositories\Operador;
use ACL\Repositories\Organizacao;
use ACL\Repositories\Organizacaooper;
use ACL\Repositories\Pais;
use ACL\Repositories\Paramgeral;
use ACL\Repositories\Parceria;
use ACL\Repositories\Parcnegocio;
use ACL\Repositories\Perfacessparc;
use ACL\Repositories\Perfilacesso;
use ACL\Repositories\Relacionaparc;
use Exception;
use ACL\Repositories\OAccTekMgr;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use ACL\Helpers\Instances\InstanceProvider;
use ACL\Util\AclUtilities;
use Teknisa\Model\Geral;

class Repository {

    /** @return  Repository */
    public static function getInstance()
    {
        return new static();
    }

    /**
     * @return Cliente
     * @throws Exception
     */
    public function getCliente(): Cliente
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Cliente');
    }

    /**
     * @return Filioper
     * @throws Exception
     */
    public function getFilioper(): Filioper
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Filioper');
    }

    /**
     * @return Inteclie
     * @throws Exception
     */
    public function getInteclie(): Inteclie
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Inteclie');
    }

    /**
     * @return Novocodigo
     * @throws Exception
     */
    public function getNovocodigo(): Novocodigo
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Novocodigo');
    }

    /**
     * @return OAccTekMgr
     * @throws Exception
     */
    public function getOAccTekMgr(): OAccTekMgr
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\OAccTekMgr');
    }

    /**
     * @return Operador
     * @throws Exception
     */
    public function getOperador(): Operador
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Operador');
    }

    /**
     * @return Organizacao
     * @throws Exception
     */
    public function getOrganizacao(): Organizacao
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Organizacao');
    }

    /**
     * @return Organizacaooper
     * @throws Exception
     */
    public function getOrganizacaooper(): Organizacaooper
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Organizacaooper');
    }

    /**
     * @return Pais
     * @throws Exception
     */
    public function getPais(): Pais
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Pais');
    }

    /**
     * @return Paramgeral
     * @throws Exception
     */
    public function getParamgeral(): Paramgeral
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Paramgeral');
    }

    /**
     * @return Parceria
     * @throws Exception
     */
    public function getParceria(): Parceria
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Parceria');
    }

    /**
     * @return Parcnegocio
     * @throws Exception
     */
    public function getParcnegocio(): Parcnegocio
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Parcnegocio');
    }

    /**
     * @return Perfacessparc
     * @throws Exception
     */
    public function getPerfacessparc(): Perfacessparc
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Perfacessparc');
    }

    /**
     * @return Perfilacesso
     * @throws Exception
     */
    public function getPerfilacesso(): Perfilacesso
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Perfilacesso');
    }

    /**
     * @return Relacionaparc
     * @throws Exception
     */
    public function getRelacionaparc(): Relacionaparc
    {
        return InstanceManager::getInstance()->getService('ACL\Repositories\Relacionaparc');
    }

    /**
     * Repositorios da lib
     */

    /** @return  \Teknisa\Libs\Util\Repositories\UserData */
    public function getLibUserData()
    {
        return InstanceManager::getInstance()->getService('libUserDataRepository');
    }

    /**
     * Repositorios antigos a serem mudados
     */

    /** @return  \Teknisa\Acl\Repositories\AclParamgeral */
    public function getAclParamgeral()
    {
        return InstanceManager::getInstance()->getService('AclParamgeralRepository');
    }

    /** @return  \Teknisa\Acl\Repositories\SqlLogs */
    public function getSqlLogsRepository()
    {
        return InstanceManager::getInstance()->getService('sqlLogsRepository');
    }

    /** @return  \Teknisa\Acl\Repositories\Crud */
    public function getCrud()
    {
        return InstanceManager::getInstance()->getService('crudRepository');
    }

    /** @return Geral\Repositories\Paramsenha */
    public static function getParamSenha()
    {
        return InstanceProvider::getEntityManager()->getRepository(AclUtilities::GERAL_ENTITY_DIR . 'Paramsenha');
    }

    /** @return Geral\Repositories\Controlsenha */
    public static function getControlSenha()
    {
        return InstanceProvider::getEntityManager()->getRepository(AclUtilities::GERAL_ENTITY_DIR . 'Controlsenha');
    }

    /** @return  \Teknisa\Acl\Repositories\GrupoOperador */
    public function getGrupoOperador()
    {
        return InstanceManager::getInstance()->getService('GrupoOperadorRepository');
    }




}
