import { Loader, Singleton } from '@zeedhi/core';
import { OperadorService } from '@/services/OperadorService';
import { LoadingService } from '@zeedhi/common';

@Singleton
export class OperadorDetailController {
	public operadorService!: OperadorService;

	constructor() {
		this.operadorService = new OperadorService();
	}

	public operadorController = Loader.getInstance('OperadorController');

	get isVisibleOperadorDetail(): boolean {
		return !this.operadorController.isVisibleOperadorGrid;
	}

	get currentOperadorName(): string {
		return this.operadorController.currentOperador.NMOPERADOR || '';
	}

	public async clickBackToOperadorGrid() {
		this.operadorController.isVisibleOperadorGrid = true;
		LoadingService.show();
		await this.operadorController.getInstanceOperadorGrid().reload();
		LoadingService.hide();
	}

	public changeOperadorDetailTabs() {
		this.operadorController.changeOperadorDetailTabs();
	}
}
